diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mesh/model/mesh-wifi-interface-mac.cc ns-3.43/src/mesh/model/mesh-wifi-interface-mac.cc
--- ns-3.42/src/mesh/model/mesh-wifi-interface-mac.cc	2024-05-29 15:29:47.132073600 -0700
+++ ns-3.43/src/mesh/model/mesh-wifi-interface-mac.cc	2024-10-09 16:41:10.052656400 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 IITP RAS
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Kirill Andreev <andreev@iitp.ru>
  *          Pavel Boyko <boyko@iitp.ru>
@@ -98,20 +87,6 @@
     return true;
 }
 
-void
-MeshWifiInterfaceMac::Enqueue(Ptr<Packet> packet, Mac48Address to, Mac48Address from)
-{
-    NS_LOG_FUNCTION(this << packet << to << from);
-    ForwardDown(packet, from, to);
-}
-
-void
-MeshWifiInterfaceMac::Enqueue(Ptr<Packet> packet, Mac48Address to)
-{
-    NS_LOG_FUNCTION(this << packet << to);
-    ForwardDown(packet, GetAddress(), to);
-}
-
 bool
 MeshWifiInterfaceMac::SupportsSendFrom() const
 {
@@ -223,20 +198,18 @@
 // Forward frame down
 //-----------------------------------------------------------------------------
 void
-MeshWifiInterfaceMac::ForwardDown(Ptr<Packet> packet, Mac48Address from, Mac48Address to)
+MeshWifiInterfaceMac::Enqueue(Ptr<WifiMpdu> mpdu, Mac48Address to, Mac48Address from)
 {
-    WifiMacHeader hdr;
-    hdr.SetType(WIFI_MAC_QOSDATA);
+    NS_LOG_FUNCTION(this << *mpdu << to << from);
+
+    auto& hdr = mpdu->GetHeader();
+    auto packet = mpdu->GetPacket()->Copy();
+
     hdr.SetAddr2(GetAddress());
     hdr.SetAddr3(to);
     hdr.SetAddr4(from);
     hdr.SetDsFrom();
     hdr.SetDsTo();
-    // Fill QoS fields:
-    hdr.SetQosAckPolicy(WifiMacHeader::NORMAL_ACK);
-    hdr.SetQosNoEosp();
-    hdr.SetQosNoAmsdu();
-    hdr.SetQosTxopLimit(0);
     // Address 1 is unknown here. Routing plugin is responsible to correctly set it.
     hdr.SetAddr1(Mac48Address());
     // Filter packet through all installed plugins
@@ -261,24 +234,12 @@
         }
         GetWifiRemoteStationManager()->RecordDisassociated(hdr.GetAddr1());
     }
-    // Classify: application may have set a tag, which is removed here
-    AcIndex ac;
-    SocketPriorityTag tag;
-    if (packet->RemovePacketTag(tag))
-    {
-        hdr.SetQosTid(tag.GetPriority());
-        ac = QosUtilsMapTidToAc(tag.GetPriority());
-    }
-    else
-    {
-        // No tag found; set to best effort
-        ac = AC_BE;
-        hdr.SetQosTid(0);
-    }
+
     m_stats.sentFrames++;
     m_stats.sentBytes += packet->GetSize();
-    NS_ASSERT(GetQosTxop(ac) != nullptr);
-    GetQosTxop(ac)->Queue(packet, hdr);
+    auto tid = hdr.GetQosTid();
+    NS_ASSERT(GetQosTxop(tid) != nullptr);
+    GetQosTxop(tid)->Queue(Create<WifiMpdu>(packet, hdr));
 }
 
 void
@@ -310,11 +271,11 @@
      */
     if (hdr.GetAddr1() != Mac48Address::GetBroadcast())
     {
-        GetQosTxop(AC_VO)->Queue(packet, header);
+        GetQosTxop(AC_VO)->Queue(Create<WifiMpdu>(packet, header));
     }
     else
     {
-        GetQosTxop(AC_BK)->Queue(packet, header);
+        GetQosTxop(AC_BK)->Queue(Create<WifiMpdu>(packet, header));
     }
 }
 
@@ -326,14 +287,14 @@
     AllSupportedRates rates;
     for (const auto& mode : GetWifiPhy()->GetModeList())
     {
-        uint16_t gi = ConvertGuardIntervalToNanoSeconds(mode, GetWifiPhy()->GetDevice());
+        const auto gi = GetGuardIntervalForMode(mode, GetWifiPhy()->GetDevice());
         rates.AddSupportedRate(mode.GetDataRate(GetWifiPhy()->GetChannelWidth(), gi, 1));
     }
     // set the basic rates
     for (uint32_t j = 0; j < GetWifiRemoteStationManager()->GetNBasicModes(); j++)
     {
-        WifiMode mode = GetWifiRemoteStationManager()->GetBasicMode(j);
-        uint16_t gi = ConvertGuardIntervalToNanoSeconds(mode, GetWifiPhy()->GetDevice());
+        const auto mode = GetWifiRemoteStationManager()->GetBasicMode(j);
+        const auto gi = GetGuardIntervalForMode(mode, GetWifiPhy()->GetDevice());
         rates.SetBasicRate(mode.GetDataRate(GetWifiPhy()->GetChannelWidth(), gi, 1));
     }
     return rates;
@@ -344,8 +305,8 @@
 {
     for (uint32_t i = 0; i < GetWifiRemoteStationManager()->GetNBasicModes(); i++)
     {
-        WifiMode mode = GetWifiRemoteStationManager()->GetBasicMode(i);
-        uint16_t gi = ConvertGuardIntervalToNanoSeconds(mode, GetWifiPhy()->GetDevice());
+        const auto mode = GetWifiRemoteStationManager()->GetBasicMode(i);
+        const auto gi = GetGuardIntervalForMode(mode, GetWifiPhy()->GetDevice());
         if (!rates.IsSupportedRate(mode.GetDataRate(GetWifiPhy()->GetChannelWidth(), gi, 1)))
         {
             return false;
@@ -433,7 +394,8 @@
     {
         (*i)->UpdateBeacon(beacon);
     }
-    m_txop->Queue(beacon.CreatePacket(), beacon.CreateHeader(GetAddress(), GetMeshPointAddress()));
+    m_txop->Queue(Create<WifiMpdu>(beacon.CreatePacket(),
+                                   beacon.CreateHeader(GetAddress(), GetMeshPointAddress())));
 
     ScheduleNextBeacon();
 }
@@ -468,8 +430,8 @@
 
             for (const auto& mode : GetWifiPhy()->GetModeList())
             {
-                uint16_t gi = ConvertGuardIntervalToNanoSeconds(mode, GetWifiPhy()->GetDevice());
-                uint64_t rate = mode.GetDataRate(GetWifiPhy()->GetChannelWidth(), gi, 1);
+                const auto gi = GetGuardIntervalForMode(mode, GetWifiPhy()->GetDevice());
+                const auto rate = mode.GetDataRate(GetWifiPhy()->GetChannelWidth(), gi, 1);
                 if (rates.IsSupportedRate(rate))
                 {
                     GetWifiRemoteStationManager()->AddSupportedMode(hdr->GetAddr2(), mode);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mesh/model/mesh-wifi-interface-mac.h ns-3.43/src/mesh/model/mesh-wifi-interface-mac.h
--- ns-3.42/src/mesh/model/mesh-wifi-interface-mac.h	2024-05-29 15:29:47.132073600 -0700
+++ ns-3.43/src/mesh/model/mesh-wifi-interface-mac.h	2024-10-09 16:41:10.052656400 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 IITP RAS
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Kirill Andreev <andreev@iitp.ru>
  *          Pavel Boyko <boyko@iitp.ru>
@@ -65,8 +54,6 @@
     ~MeshWifiInterfaceMac() override;
 
     // Inherited from WifiMac
-    void Enqueue(Ptr<Packet> packet, Mac48Address to, Mac48Address from) override;
-    void Enqueue(Ptr<Packet> packet, Mac48Address to) override;
     bool SupportsSendFrom() const override;
     void SetLinkUpCallback(Callback<void> linkUp) override;
     bool CanForwardPacketsTo(Mac48Address to) const override;
@@ -234,14 +221,6 @@
      */
     void Receive(Ptr<const WifiMpdu> mpdu, uint8_t linkId) override;
     /**
-     * Send frame. Frame is supposed to be tagged by routing information.
-     *
-     * \param packet the packet to forward
-     * \param from the from address
-     * \param to the to address
-     */
-    void ForwardDown(Ptr<Packet> packet, Mac48Address from, Mac48Address to);
-    /**
      * Send beacon.
      */
     void SendBeacon();
@@ -264,6 +243,7 @@
     typedef std::vector<Ptr<MeshWifiInterfaceMacPlugin>> PluginList; ///< PluginList typedef
 
     void DoInitialize() override;
+    void Enqueue(Ptr<WifiMpdu> mpdu, Mac48Address to, Mac48Address from) override;
 
     /// \name Mesh timing intervals
     ///@{
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mesh/model/mesh-wifi-interface-mac-plugin.h ns-3.43/src/mesh/model/mesh-wifi-interface-mac-plugin.h
--- ns-3.42/src/mesh/model/mesh-wifi-interface-mac-plugin.h	2024-05-29 15:29:47.132073600 -0700
+++ ns-3.43/src/mesh/model/mesh-wifi-interface-mac-plugin.h	2024-10-09 16:41:10.052656400 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 IITP RAS
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Pavel Boyko <boyko@iitp.ru>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mesh/test/dot11s/dot11s-test-suite.cc ns-3.43/src/mesh/test/dot11s/dot11s-test-suite.cc
--- ns-3.42/src/mesh/test/dot11s/dot11s-test-suite.cc	2024-05-29 15:29:47.132073600 -0700
+++ ns-3.43/src/mesh/test/dot11s/dot11s-test-suite.cc	2024-10-09 16:41:10.052656400 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 IITP RAS
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Pavel Boyko <boyko@iitp.ru>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mesh/test/dot11s/hwmp-proactive-regression.cc ns-3.43/src/mesh/test/dot11s/hwmp-proactive-regression.cc
--- ns-3.42/src/mesh/test/dot11s/hwmp-proactive-regression.cc	2024-05-29 15:29:47.132073600 -0700
+++ ns-3.43/src/mesh/test/dot11s/hwmp-proactive-regression.cc	2024-10-09 16:41:10.052656400 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 IITP RAS
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Kirill Andreev  <andreev@iitp.ru>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mesh/test/dot11s/hwmp-proactive-regression.h ns-3.43/src/mesh/test/dot11s/hwmp-proactive-regression.h
--- ns-3.42/src/mesh/test/dot11s/hwmp-proactive-regression.h	2024-05-29 15:29:47.132073600 -0700
+++ ns-3.43/src/mesh/test/dot11s/hwmp-proactive-regression.h	2024-10-09 16:41:10.056656600 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 IITP RAS
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Kirill Andreev  <andreev@iitp.ru>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mesh/test/dot11s/hwmp-reactive-regression.cc ns-3.43/src/mesh/test/dot11s/hwmp-reactive-regression.cc
--- ns-3.42/src/mesh/test/dot11s/hwmp-reactive-regression.cc	2024-05-29 15:29:47.132073600 -0700
+++ ns-3.43/src/mesh/test/dot11s/hwmp-reactive-regression.cc	2024-10-09 16:41:10.056656600 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 IITP RAS
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Kirill Andreev <andreev@iitp.ru>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mesh/test/dot11s/hwmp-reactive-regression.h ns-3.43/src/mesh/test/dot11s/hwmp-reactive-regression.h
--- ns-3.42/src/mesh/test/dot11s/hwmp-reactive-regression.h	2024-05-29 15:29:47.132073600 -0700
+++ ns-3.43/src/mesh/test/dot11s/hwmp-reactive-regression.h	2024-10-09 16:41:10.056656600 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 IITP RAS
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Kirill Andreev <andreev@iitp.ru>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mesh/test/dot11s/hwmp-simplest-regression.cc ns-3.43/src/mesh/test/dot11s/hwmp-simplest-regression.cc
--- ns-3.42/src/mesh/test/dot11s/hwmp-simplest-regression.cc	2024-05-29 15:29:47.132073600 -0700
+++ ns-3.43/src/mesh/test/dot11s/hwmp-simplest-regression.cc	2024-10-09 16:41:10.056656600 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 IITP RAS
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Kirill Andreev  <andreev@iitp.ru>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mesh/test/dot11s/hwmp-simplest-regression.h ns-3.43/src/mesh/test/dot11s/hwmp-simplest-regression.h
--- ns-3.42/src/mesh/test/dot11s/hwmp-simplest-regression.h	2024-05-29 15:29:47.132073600 -0700
+++ ns-3.43/src/mesh/test/dot11s/hwmp-simplest-regression.h	2024-10-09 16:41:10.056656600 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 IITP RAS
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Kirill Andreev  <andreev@iitp.ru>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mesh/test/dot11s/hwmp-target-flags-regression.cc ns-3.43/src/mesh/test/dot11s/hwmp-target-flags-regression.cc
--- ns-3.42/src/mesh/test/dot11s/hwmp-target-flags-regression.cc	2024-05-29 15:29:47.132073600 -0700
+++ ns-3.43/src/mesh/test/dot11s/hwmp-target-flags-regression.cc	2024-10-09 16:41:10.056656600 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 IITP RAS
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Kirill Andreev  <andreev@iitp.ru>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mesh/test/dot11s/hwmp-target-flags-regression.h ns-3.43/src/mesh/test/dot11s/hwmp-target-flags-regression.h
--- ns-3.42/src/mesh/test/dot11s/hwmp-target-flags-regression.h	2024-05-29 15:29:47.132073600 -0700
+++ ns-3.43/src/mesh/test/dot11s/hwmp-target-flags-regression.h	2024-10-09 16:41:10.056656600 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 IITP RAS
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Kirill Andreev  <andreev@iitp.ru>
  */
@@ -30,41 +19,45 @@
  *
  * \brief This is a test for intermediate reply and saving routing
  * information about neighbour. 4 stations and 3 UDP ping streams are initiated.
+ */
+// clang-format off
+/**
  * \verbatim
- *  <-----------|----------->   Broadcast frame
- *              |----------->|  Unicast frame
- * (Node ID)   0           1             2            3
- * (MAC addr) 10           11           12           13
- *             |            |<-----------|----------->|             ARP request (12 asks who has 10)
- *             |            |            |<-----------|-----------> ARP request
- *             |<-----------|----------->|            |             ARP request
- * <-----------|----------->|            |            |             PREQ
- *             |<-----------|----------->|            |             PREQ
- *             |            |<-----------|            |             PREP
- *             |<-----------|            |            |             PREP
- *             |----------->|            |            |             ARP reply
- *             |            |----------->|            |             ARP REPLY
- *             |            |<-----------|            |             Data
- *             |............|............|............|
- *             |<-----------|----------->|            |             ARP request (11 asks who has 10)
- *             |............|............|............|
- *             |----------->|            |            |             ARP reply
- *                  ^ Note, that this arp reply goes without route
- *                  discovery procedure, because route is known from
- *                  previous PREQ/PREP exchange
- *             |<-----------|            |            |             DATA
- *             |............|............|............|
- * <-----------|----------->|            |            |             ARP request (10 asks who has 13)
- *             |............|............|............|
- *             |            |            |<-----------|-----------> PREQ (13 asks about 10) DO=0
- * RF=1 |            |            |----------->|             PREP (intermediate reply - 12 knows
- * about 10) |            |<-----------|----------->|             PREQ DO=1 RF=0
- *             |............|............|............|
- *             |----------->|            |            |             PREP
- *             |            |----------->|            |             PREP
- *             |            |            |----------->|             PREP
- * \endverbatim
+   <-----------|----------->   Broadcast frame
+               |----------->|  Unicast frame
+   (Node ID)   0            1            2            3
+   (MAC addr) 10           11           12           13
+               |            |<-----------|----------->|             ARP request (12 asks who has 10)
+               |            |            |<-----------|-----------> ARP request
+               |<-----------|----------->|            |             ARP request
+   <-----------|----------->|            |            |             PREQ
+               |<-----------|----------->|            |             PREQ
+               |            |<-----------|            |             PREP
+               |<-----------|            |            |             PREP
+               |----------->|            |            |             ARP reply
+               |            |----------->|            |             ARP REPLY
+               |            |<-----------|            |             Data
+               |............|............|............|
+               |<-----------|----------->|            |             ARP request (11 asks who has 10)
+               |............|............|............|
+               |----------->|            |            |             ARP reply
+                    ^ Note, that this arp reply goes without route
+                    discovery procedure, because route is known from
+                    previous PREQ/PREP exchange
+               |<-----------|            |            |             DATA
+               |............|............|............|
+   <-----------|----------->|            |            |             ARP request (10 asks who has 13)
+               |............|............|............|
+               |            |            |<-----------|-----------> PREQ (13 asks about 10) DO=0 RF=1
+               |            |            |----------->|             PREP (intermediate reply - 12 knows about 10)
+               |            |<-----------|----------->|             PREQ DO=1 RF=0
+               |............|............|............|
+               |----------->|            |            |             PREP
+               |            |----------->|            |             PREP
+               |            |            |----------->|             PREP
+   \endverbatim
  */
+// clang-format on
 class HwmpDoRfRegressionTest : public TestCase
 {
   public:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mesh/test/dot11s/pmp-regression.cc ns-3.43/src/mesh/test/dot11s/pmp-regression.cc
--- ns-3.42/src/mesh/test/dot11s/pmp-regression.cc	2024-05-29 15:29:47.132073600 -0700
+++ ns-3.43/src/mesh/test/dot11s/pmp-regression.cc	2024-10-09 16:41:10.056656600 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 IITP RAS
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Pavel Boyko <boyko@iitp.ru>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mesh/test/dot11s/pmp-regression.h ns-3.43/src/mesh/test/dot11s/pmp-regression.h
--- ns-3.42/src/mesh/test/dot11s/pmp-regression.h	2024-05-29 15:29:47.132073600 -0700
+++ ns-3.43/src/mesh/test/dot11s/pmp-regression.h	2024-10-09 16:41:10.056656600 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 IITP RAS
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Pavel Boyko <boyko@iitp.ru>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mesh/test/dot11s/regression.cc ns-3.43/src/mesh/test/dot11s/regression.cc
--- ns-3.42/src/mesh/test/dot11s/regression.cc	2024-05-29 15:29:47.132073600 -0700
+++ ns-3.43/src/mesh/test/dot11s/regression.cc	2024-10-09 16:41:10.056656600 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 IITP RAS
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Kirill Andreev <andreev@iitp.ru>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mesh/test/flame/flame-regression.cc ns-3.43/src/mesh/test/flame/flame-regression.cc
--- ns-3.42/src/mesh/test/flame/flame-regression.cc	2024-05-29 15:29:47.136073600 -0700
+++ ns-3.43/src/mesh/test/flame/flame-regression.cc	2024-10-09 16:41:10.056656600 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 IITP RAS
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Kirill Andreev <andreev@iitp.ru>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mesh/test/flame/flame-regression.h ns-3.43/src/mesh/test/flame/flame-regression.h
--- ns-3.42/src/mesh/test/flame/flame-regression.h	2024-05-29 15:29:47.136073600 -0700
+++ ns-3.43/src/mesh/test/flame/flame-regression.h	2024-10-09 16:41:10.056656600 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 IITP RAS
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Kirill Andreev <andreev@iitp.ru>
  */
